#include "CyanBus.hpp"

// C++ system level
#include <cinttypes>
#include <functional>

// ESP32 specific
#include "esp_log.h"
#include "driver/gpio.h"
#include "driver/uart.h"

// project specific
#include "LambdaTask.hpp"

// qthing stuff
// #include ""



static const char* TAG = "CyanBus";


// This leads to ~54 P/s @ 2 MBaud at 100% load
// TODO: Make configurable?!
const uint32_t CyanBusMTU = 4096;


namespace SiliconTorch {

  namespace CyanBus {


    CyanBus::CyanBus(Reader reader) : reader(reader) {

      readerTaskHandle = new SiliconTorch::Util::LambdaTask([&](){ readerTask(); });

    }

    void CyanBus::readerTask() {
      const uint8_t* header = (const uint8_t*)"fxCyan";
      uint8_t* buffer = new uint8_t[CyanBusMTU];

      enum FSM { SearchHeader };
      FSM fsm = SearchHeader;

      uint8_t headerIDX = 0;

      while (true) {

        ESP_LOGW(TAG, "Hello, ReaderTask()!  My header is: %s", header);

        vTaskDelay(420);

        continue;

        switch (fsm) {
          case SearchHeader: {

            break;
          }
        }
      }

      delete buffer;
    }

    void CyanBus::setBaudRate(uint32_t baudRate) {
      ESP_LOGE(TAG, "Operation unsupported: setBaudRate(…)");
    }

    uint32_t CyanBus::getBaudRate() {
      ESP_LOGE(TAG, "Operation unsupported: getBaudRate()");
      return 1337;
    }
  }
}



