#pragma once

// C++ system level
#include <string>
#include <cinttypes>
#include <functional>

// project specific
#include "LambdaTask.hpp"


namespace SiliconTorch {

  namespace CyanBus {

    typedef std::function<uint8_t*(uint32_t)> Reader;

    class CyanBus {
      public:
        CyanBus(Reader reader);

        // TODO: How do we wanna set baudRates when we only have a reader?!
        // TODO: Elaborate on this topic!
        uint32_t getBaudRate();
        void setBaudRate(uint32_t baudRate);

      private:

        Reader reader;

        void readerTask();

        SiliconTorch::Util::LambdaTask* readerTaskHandle = NULL;

    };
  }
}
